<?php

namespace Teknisa\MAN\Services;

use Doctrine\DBAL\Connection;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services\NovoCodigo;

class AberturaCaixaService {

    protected $conn;

    public function __construct(Connection $conn) {
        $this->conn = $conn;
    }

    public function getNrSequenciaMovimentacao($cdcontadorMovcaixa,$NrOrg,$size){
        return NovoCodigo::geraCodigo($this->conn,$cdcontadorMovcaixa,$NrOrg,10);
    }
    
    
     public function saveMovCaixa($row){
        $currentDate = new \DateTime();
        $params = array(
            ':CDFILIAL' =>  $row['CDFILIAL'],
            ':CDCAIXA'  =>  $row['CDCAIXA'],
            ':DTABERCAIX'   =>  $row['DTABERCAIX'],
            ':NRSEQUMOVI'   =>  $this->getNrSequenciaMovimentacao( 'MOVCAIXA'.$row['CDFILIAL'].$row['CDCAIXA'].$row['DTABERCAIX'],$row['NRORG'],10),
            ':IDTIPOMOVIVE' =>  'A',
            ':DSMOVIVEND'   =>  $row['DSOBSCAIXA'],
            ':VRMOVIVEND'   =>  $row['VRMOVIVEND'],
            ':CDTIPORECE'   =>  $row['CDTIPORECE'],
            ':DTHRINCMOV'   =>  $row['DTABERCAIX'],
            ':NRCONTRAVALE' =>  '',
            ':DTMOVIMCAIXA' =>  $currentDate->format("d/m/Y"),
            ':NRORG'    =>  $row['NRORG'],
            ':NRORGINCLUSAO'    =>  $row['NRORG'],
            ':NRORGULTATU'  =>  $row['NRORG'],
            ':CDOPERINCLUSAO'   =>  $row['CDOPERADOR'],
            ':CDOPERULTATU' =>  $row['CDOPERADOR']
        );
        $this->conn->executeQuery(Utilities\Query::INSERT_MOVCAIXA_ABERTURA, $params);
        
        return $params[':NRSEQUMOVI'];
    }
    
    public function isRegisterOpen($CDFILIAL,$CDCAIXA,$NRORG,$DTABERTURA){
        $params = array(
            ':CDFILIAL'     => $CDFILIAL,
            ':CDCAIXA'      => $CDCAIXA,
            ':NRORG'        => $NRORG,
            ':DTABERTURA'   => $DTABERTURA
        );
        $result = $this->conn->fetchAll(self::IS_REGISTER_OPEN,$params);
        
        if(empty($result)){
            return false;
        } else
        {
            
        return $result[0]["DTFECHCAIX"];
    
        } 
        
    }
    public function getAbertura($CDFILIAL,$CDCAIXA,$NRORG,$DTABERTURA){
        $params = array(
            ':CDFILIAL'     => $CDFILIAL,
            ':CDCAIXA'      => $CDCAIXA,
            ':NRORG'        => $NRORG,
            ':DTABERTURA'   => $DTABERTURA
        );
        $result = $this->conn->fetchAll(self::IS_REGISTER_OPEN,$params);
        
        if(empty($result)){
            return false;
        } else {
            return array(
                'DTFECHCAIX' => $result[0]['DTFECHCAIX'], 
                'DTABERCAIX' => $result[0]['DTABERCAIX']
            );
        }
    }
    
     const IS_REGISTER_OPEN = "
      SELECT
      TC.CDOPERADOR,
      OP.NMOPERADOR, 
      TC.DTABERCAIX, 
      TC.DTFECHCAIX
      FROM
      TURCAIXA TC,
      OPERADOR OP
      WHERE
      (TC.CDFILIAL = :CDFILIAL) AND
      (TC.CDCAIXA = :CDCAIXA) AND
      (TC.NRORG = :NRORG) AND
      (TC.CDOPERADOR = OP.CDOPERADOR(+)) AND
      ((DTFECHCAIX IS NULL) OR (TO_DATE(:DTABERTURA,'DD/MM/YYYY HH24:MI:SS') BETWEEN DTABERCAIX AND DTFECHCAIX))
    ";
  
}