<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class AtualizaFilialConsumidorService {

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
  
    public function find($conditions) {
        $params = array(
            ":CDOPERADOR"   => $conditions['CDOPERADOR'],
            ':CDCLIENTE'    => $conditions['CDCLIENTE'],
            ':NRORG'        => $conditions['NRORG']
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_FILIAL_CLIE, $params);
    }
    
    public function atualizaUnidade($conditions) {
        try{
            foreach ($conditions['CDFILIAL'] as $CDFILIAL) {
                
                $params = array(
                    ":CDFILIAL"   => $CDFILIAL,
                    ':NRORG'      => $conditions['NRORG']
                );
                $return = $this->entityManager->getConnection()->executeQuery(self::UPDT_UNIDADE, $params);
            }
            return $return;
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
    const GET_FILIAL_CLIE = "
    SELECT CF.CDCLIENTE,
        CF.CDFILIAL,
        FO.CDOPERADOR,
        CF.NRORG,
        F.NMFILIAL
    FROM CLIENFILIAL CF
    JOIN FILIAL F
        ON F.CDFILIAL = CF.CDFILIAL
    JOIN FILIOPER FO
        ON FO.CDFILIAL     = CF.CDFILIAL
    WHERE CF.CDCLIENTE = :CDCLIENTE
        AND FO.CDOPERADOR  = :CDOPERADOR
        AND CF.NRORG       = :NRORG";
        
    const UPDT_UNIDADE = "
    INSERT INTO CONSUMIFILIAL (CDCLIENTE, CDCONSUMIDOR, CDFILIAL)
        (SELECT C.CDCLIENTE, C.CDCONSUMIDOR, F.CDFILIAL
           FROM CONSUMIDOR C, CLIENFILIAL F
          WHERE C.CDCLIENTE      = F.CDCLIENTE
            AND C.IDSITCONSUMI   = '1'
            AND F.IDPERMVENDAFOS = 'S'
            AND F.CDFILIAL       = :CDFILIAL
            AND C.CDCONSUMIDOR NOT IN (SELECT CDCONSUMIDOR
                                         FROM CONSUMIFILIAL
                                        WHERE CDCLIENTE    = C.CDCLIENTE
                                          AND CDCONSUMIDOR = C.CDCONSUMIDOR
                                          AND CDFILIAL     = :CDFILIAL
                                          AND NRORG        = :NRORG))";
}