<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class CadChefeService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
		$this->connection = $entityManager->getConnection();
    }
    
    public function saveChefe($row){
        $params = array(
            ':CDCHEFE' => $row['CDCHEFE'],
            ':NMCHEFE' => $row['NMCHEFE'],
            ':NRORG'   => $row['NRORG']
 		);

 		$this->entityManager->getConnection()->executeQuery(self::INSERT_CHEFE, $params);
    }
    
    const INSERT_CHEFE = "
        INSERT INTO CHEFE(CDCHEFE, NMCHEFE, NRORG)
            VALUES(:CDCHEFE, :NMCHEFE, :NRORG)
    ";

    public function deleteChefeCascade($row) {
        $params = array(
            ':CDCHEFE'  => $row['CDCHEFE'],
            ':NRORG'    => $row['NRORG']
 		);

 		$this->entityManager->getConnection()->executeQuery(self::DELETE_UNIDADE_CHEFE, $params);
 		return $this->entityManager->getConnection()->executeQuery(self::DELETE_CHEFE, $params);
    }
    
    const DELETE_UNIDADE_CHEFE = "
        DELETE FROM CHEFEFILIAL
            WHERE CDCHEFE = :CDCHEFE
                AND NRORG = :NRORG
    ";
    
    const DELETE_CHEFE = "
        DELETE FROM CHEFE 
            WHERE NRORG = :NRORG 
                AND CDCHEFE = :CDCHEFE
    ";
    
    public function saveFilial($row) {
        $params = array(
            ':CDCHEFE'  => $row['CDCHEFE'],
            ':CDFILIAL' => $row['CDFILIAL'],
            ':NRORG'    => $row['NRORG']
 		);

 		$this->entityManager->getConnection()->executeQuery(self::INSERT_UNIDADE, $params);
    }
    
    const INSERT_UNIDADE = "
        INSERT INTO CHEFEFILIAL(CDCHEFE, CDFILIAL, NRORG)
            VALUES(:CDCHEFE, :CDFILIAL, :NRORG)
    ";
    
    public function deleteFilial($row) {
        $params = array(
            ':CDCHEFE'  => $row['CDCHEFE'],
            ':CDFILIAL' => $row['CDFILIAL'],
            ':NRORG'    => $row['NRORG']
 		);

 		$this->entityManager->getConnection()->executeQuery(self::DELETE_UNIDADE, $params);
    }
    
    const DELETE_UNIDADE = "
        DELETE FROM CHEFEFILIAL
            WHERE CDCHEFE = :CDCHEFE
                AND CDFILIAL = :CDFILIAL
                AND NRORG = :NRORG
    ";
}