<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class ParaVendaOnline {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function parametrizarVendaGeral(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAMS_VENDA_GERAL);
	}

	public function atualizaVendaGeral($IDCADPRODCMP, $DSPREVCONSPDV, $DSDIRSALVCAT, $DSDIRDESTARQTC, $IDUTTABPRECLVDC, $IDBLOQSEMIMP, $IDEXCONSATGER, $DSDIRARQXMLNFCE){
		$params = array(
			':IDCADPRODCMP'    => $IDCADPRODCMP,
			':DSPREVCONSPDV'   => $DSPREVCONSPDV,
			':DSDIRSALVCAT'    => $DSDIRSALVCAT,
			':DSDIRDESTARQTC'  => $DSDIRDESTARQTC,
			':IDUTTABPRECLVDC' => $IDUTTABPRECLVDC,
			':IDBLOQSEMIMP'    => $IDBLOQSEMIMP,
			':IDEXCONSATGER'   => $IDEXCONSATGER,
			':DSDIRARQXMLNFCE' => $DSDIRARQXMLNFCE
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PARAMS_VENDA_GERAL, $params);
	}

	public function atualizaParaTEFMobile($IDTPTEF, $CDFILIAL, $CDCAIXA){
		// MUDAR O CAMPO
		$params = array(
			':IDTPTEF' => $IDTPTEF,
			':CDFILIAL' => $CDFILIAL,
			':CDCAIXA' => $CDCAIXA
		);
		//
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PARAMS_TEF_MOBILE, $params);
	}

	public function getVendaFiliais($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_FILIAL, $params);
	}
}